## oracle知识点总结
* sql语句执行的过程
  * 语法分析,分析语句的语法是否符合规范，衡量语句中各表达式的意义。
  * 语义分析，检查语句中涉及的所有数据库对象是否存在，且用户有相应的权限。
  * 视图转换，将涉及视图的查询语句转换为相应的对基表查询语句。
  * 表达式转换， 将复杂的 SQL 表达式转换为较简单的等效连接表达式。
  * 选择优化器，不同的优化器一般产生不同的“执行计划”
  * 选择连接方式， ORACLE 有三种连接方式，对多表连接 ORACLE 可选择适当的连接方式。
  * 选择连接顺序， 对多表连接 ORACLE 选择哪一对表先连接，选择这两表中哪个表做为源数据表。
  * 选择数据的搜索路径，根据以上条件选择合适的数据搜索路径，如是选用全表搜索还是利用索引或是其他的方式。
  * 运行“执行计划”
* Select语句完整的执行顺序
  * from子句组装来自不同数据源的数据
  * where子句基于指定的条件对记录行进行筛选；
  * group by子句将数据划分为多个分组；
  * 使用聚集函数进行计算
  * 使用having子句筛选分组
  * 计算所有的表达式
  * 使用order by对结果集进行排序
* 解释冷备份和热备份的不同点以及各自的优点
  * 热备份针对归档模式的数据库，在数据库仍旧处于工作状态时进行备份。而冷备份指在数据库关闭后，进行备份，适用于所有模式的数据库。
  * 热备份的优点在于当备份时，数据库仍旧可以被使用并且可以将数据库恢复到任意一个时间点。冷备份的优点在于它的备份和恢复操作相当简单，并且由于冷备份的数据库可以工作在非归档模式下,数据库性能会比归档模式稍好。
* 你必须利用备份恢复数据库，但是你没有控制文件，该如何解决问题呢?
  重建控制文件，用带backup control file 子句的recover 命令恢复数据库。
* 如何转换init.ora到spfile
  ```sql
  create spfile from pfile ;
  ```
* 数据库中的最小读写操做以什么为单位
  * 块:块是存储数据信息的最小单位,主要构成:
	* 数据块头：主要包含有数据块地址的一些基本信息和段的类型，以及表和包含有数据的实际行的地址。
	* 自由空间：是指可以为以后的更新和插入操作分配的空间，大小由PCTFREE和PCTUSED两个参数影响。
	* 实际数据：是指在行内存储的实际数据。
  * 段:占用磁盘上存储空间的一个对象,最常见的段类型:聚促、表、表分区、索引、索引分区、LOB分区、LOB子分区、LOB索引、嵌套表、会滚段等
